Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.

Count the number of distinct islands. An island is considered to be the same as another if and only if one island can be translated (and not rotated or reflected) to equal the other.

Example 1:

11000
11000
00011
00011

Given the above grid map, return 1.

Example 2:

11011
10000
00001
11011

Given the above grid map, return 3.

Notice that:

11
1

and

 1
11

are considered different island shapes, because we do not consider reflection / rotation.

Note: The length of each dimension in the given grid does not exceed 50.

这道题让我们求不同岛屿的个数,是之前那道 Number of Islands 的拓展,难点是如何去判断两个岛屿是否是不同的岛屿,首先1的个数肯定是要相同,但是1的个数相同不能保证一定是相同的岛屿,比如例子2中的那两个岛屿的就不相同,就是说两个相同的岛屿通过平移可以完全重合,但是不能旋转。如何来判断呢,可以发现可以通过相对位置坐标来判断,比如使用岛屿的最左上角的1当作基点,那么基点左边的点就是 (0,-1),右边的点就是 (0,1), 上边的点就是 (-1,0),下面的点就是 (1,0)。则例子1中的两个岛屿都可以表示为 [(0,0), (0,1), (1,0), (1,1)],点的顺序是基点-右边点-下边点-右下点。通过这样就可以判断两个岛屿是否相同了,下面这种解法没有用数组来存,而是 encode 成了字符串,比如这四个点的数组就存为 "0_0_0_1_1_0_1_1_",然后把字符串存入集合 unordered_set 中,利用其自动去重复的特性,就可以得到不同的岛屿的数量啦,参见代码如下:

解法一:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
unordered_set<string> res;
vector<vector<bool>> visited(m, vector<bool>(n, false));
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] == && !visited[i][j]) {
set<string> s;
helper(grid, i, j, i, j, visited, s);
string t = "";
for (auto str : s) t += str + "_";
res.insert(t);
}
}
}
return res.size();
}
void helper(vector<vector<int>>& grid, int x0, int y0, int i, int j, vector<vector<bool>>& visited, set<string>& s) {
int m = grid.size(), n = grid[].size();
visited[i][j] = true;
for (auto dir : dirs) {
int x = i + dir[], y = j + dir[];
if (x < || x >= m || y < || y >= n || grid[x][y] == || visited[x][y]) continue;
string str = to_string(x - x0) + "_" + to_string(y - y0);
s.insert(str);
helper(grid, x0, y0, x, y, visited, s);
}
}
};

当然我们也可以不 encode 字符串,直接将相对坐标存入数组中,然后把整个数组放到集合 set 中,还是会去掉相同的数组,而且这种解法直接在 grid 数组上标记访问过的位置,写起来更加简洁了,参见代码如下:

解法二:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
set<vector<pair<int, int>>> res;
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] != ) continue;
vector<pair<int, int>> v;
helper(grid, i, j, i, j, v);
res.insert(v);
}
}
return res.size();
}
void helper(vector<vector<int>>& grid, int x0, int y0, int i, int j, vector<pair<int, int>>& v) {
int m = grid.size(), n = grid[].size();
if (i < || i >= m || j < || j >= n || grid[i][j] <= ) return;
grid[i][j] *= -;
v.push_back({i - x0, j - y0});
for (auto dir : dirs) {
helper(grid, x0, y0, i + dir[], j + dir[], v);
}
}
};

既然递归 DFS 可以,那么迭代的 BFS 就坐不住了,其实思路没什么区别,这种类似迷宫遍历的题都是一个套路,整体框架都很像,细枝末节需要改改就行了,参见代码如下:

解法三:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
set<vector<pair<int, int>>> res;
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] != ) continue;
vector<pair<int, int>> v;
queue<pair<int, int>> q{{{i, j}}};
grid[i][j] *= -;
while (!q.empty()) {
auto t = q.front(); q.pop();
for (auto dir : dirs) {
int x = t.first + dir[], y = t.second + dir[];
if (x < || x >= m || y < || y >= n || grid[x][y] <= ) continue;
q.push({x, y});
grid[x][y] *= -;
v.push_back({x - i, y - j});
}
}
res.insert(v);
}
}
return res.size();
}
};

Github 同步地址:

https://github.com/grandyang/leetcode/issues/694

类似题目:

Number of Islands

Number of Distinct Islands II

参考资料:

https://leetcode.com/problems/number-of-distinct-islands/

https://leetcode.com/problems/number-of-distinct-islands/discuss/150037/DFS-with-Explanations

https://leetcode.com/problems/number-of-distinct-islands/discuss/108474/JavaC%2B%2B-Clean-Code

https://leetcode.com/problems/number-of-distinct-islands/discuss/108475/Java-very-Elegant-and-concise-DFS-Solution(Beats-100)

LeetCode All in One 题目讲解汇总(持续更新中...)

最新文章

  1. Linux自动共享USB设备:udev+Samba
  2. Linux下oracle环境变量无效问题
  3. linux shell:mysql bin_log定期清理脚本
  4. Spring web.xml配置文件解析
  5. Codeforces Round #367 (Div. 2)---水题 | dp | 01字典树
  6. svn老鸟转用git必须理解的概念
  7. kvm guest usb mapping
  8. Android 抓包,监控流量工具之 mitmproxy
  9. Red and Black(dfs水)
  10. Netty未来展望
  11. Nessus更新到8.3.0
  12. 微信小程序视频学习笔记
  13. shell脚本学习系列之一---入门
  14. C++学习的书籍
  15. salesforce lightning零基础学习(十) Aura Js 浅谈三: $A、Action、Util篇
  16. C# 异步编程3 TPL Task 异步程序开发
  17. AndroidStudio_ListView
  18. Android Service GetSystemService
  19. 栈空间默认1M,测试存进数据时间
  20. webstorm的个性化设置settings

热门文章

  1. java排序算法(六):直接插入排序
  2. RESTFul API设计指南及使用说明
  3. sphinx的安装
  4. 第六周PTA作业
  5. C语言第四次博客作业
  6. 学号:201621123032 《Java程序设计》第10周学习总结
  7. selenium 爬虫
  8. XML使用练习
  9. Java 多线程 从无到有
  10. 分布式系统之消息中间件rabbitmq